<id>
Reorder Post independent Member Groups for YaBB 2.2
</id>

<version>
1.0
</version>

<mod info>

Apply this mod.

This mod will allow admin to reorder post independent member groups.

Upload (in ASCII mode):

cgi-bin/yabb2/AdminIndex.pl
cgi-bin/yabb2/YaBB.pl
cgi-bin/yabb2/Admin/AdminSubList.pl
cgi-bin/yabb2/Admin/MailMembers.pl
cgi-bin/yabb2/Admin/ManageBoards.pl
cgi-bin/yabb2/Admin/MemberGroups.pl
cgi-bin/yabb2/Admin/ModList.pl
cgi-bin/yabb2/Languages/English/Admin.lng
cgi-bin/yabb2/Sources/BoardIndex.pl
cgi-bin/yabb2/Sources/Profile.pl
cgi-bin/yabb2/Sources/Register.pl
cgi-bin/yabb2/Sources/Subs.pl
cgi-bin/yabb2/Sources/UserSelect.pl

</mod info>

<author>
Carsten
</author>


<Edit file>
AdminIndex.pl
</Edit file>

<search for>
&banning;   # Check for banned people
</search for>

<add before>
&nopostorder; # Create nopostorder array
</add before>


<Edit file>
YaBB.pl
</Edit file>

<search for>
&LoadIMs;     # Load IM's
</search for>

<add after>
&nopostorder; # Create nopostorder array
</add after>


<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
'removeoldthreads',"RemoveOldTopics.pl&RemoveOldThreads",
</search for>

<add after>
'reordergroup',"MemberGroups.pl&reorderGroups",
'reordergroup2',"MemberGroups.pl&reorderGroups2",
</add after>



<edit file>
Admin/MailMembers.pl
</edit file>

<search for>
	foreach (sort { $a <=> $b } keys %NoPost) {
		($title, $dummy) = split(/\|/, $NoPost{$_}, 2);
		$grpselect .= qq~\n<option value="$_"> $title</option>~;
		$groupcnt++;
	}
</search for>

<replace>
	foreach (@nopostorder) {
		chomp $_;
		($title, $dummy) = split(/\|/, $NoPost{$_}, 2);
		$grpselect .= qq~\n<option value="$_"> $title</option>~;
		$groupcnt++;
	}
</replace>

<search for>
		$grp_data .= qq~"'$title'", ~;

		foreach (sort { $a <=> $b } keys %NoPost) {
</search for>

<replace>
		$grp_data .= qq~"'$title'", ~;

		foreach (@nopostorder) {
			chomp $_;
</replace>


<edit file>
Admin/ManageBoards.pl
</edit file>

<search for>
		my $box = "";
		foreach (sort { $a <=> $b } keys %NoPost) {
</search for>

<replace>
		my $box = "";
		foreach (@nopostorder) {
			chomp $_;
</replace>

<search for>
			foreach (sort { $a <=> $b } keys %NoPost) {
</search for>

<replace>
			foreach (@nopostorder) {
				chomp $_;
</replace>


<edit file>
Admin/MemberGroups.pl
</edit file>

<search for>
		$width3 = '10%';
	}
</search for>

<add after>
	my $reorderlink = "";
	if($#nopostorder > 0) {
		$reorderlink = qq~ | <a href="$adminurl?action=reordergroup">$admintxt{'reordergroups'}</a>~;
	}
</add after>

<search for>
		<img src="$imagesdir/guest.gif" alt="" border="0" />&nbsp;<b>$amgtxt{'37'} (<a href="$adminurl?action=editgroup">$admintxt{'18c'}</a>)</b>
</search for>

<replace>
		<img src="$imagesdir/guest.gif" alt="" border="0" />&nbsp;<b>$amgtxt{'37'} (<a href="$adminurl?action=editgroup">$admintxt{'18c'}</a>$reorderlink)</b>
</replace>


<search for>
	foreach (sort { $a <=> $b } keys %NoPost) {
</search for>

<replace>
	foreach (@nopostorder) {
		chomp $_;
</replace>

<search for>
			next;
		}
		($title, $stars, $starpic, $color, $noshow, $viewperms, $topicperms, $replyperms, $pollperms, $attachperms, $additional) = split(/\|/, $NoPost{$_});
</search for>

<add before>
			fopen(NPORDER, ">$vardir/nopostorder.txt",1);
			for ($i = 0; $i < @nopostorder; $i++) {
				chomp $nopostorder[$i];
				unless($nopostorder[$i] eq $_) {
					print NPORDER "$nopostorder[$i]\n";
				}
			}
			fclose(NPORDER);
			if (!-s "$vardir/nopostorder.txt") { unlink("$vardir/nopostorder.txt"); }
</add before>

<search for>
			} elsif ($type eq "NP") {
				if ($element != $noposts || $postdepend eq "Yes") {
					delete $NoPost{$element};
</search for>

<add after>

					fopen(NPORDER, ">$vardir/nopostorder.txt",1);
					for ($i = 0; $i < @nopostorder; $i++) {
						chomp $nopostorder[$i];
						if($NoPost{$nopostorder[$i]}) {
							print NPORDER "$nopostorder[$i]\n";
						}
					}
					fclose(NPORDER);
</add after>

<search for>
			# no post group
			$NoPost{$noposts} = "$name|$FORM{'numstars'}|$star|$color|$viewpublic|$view|$topics|$reply|$polls|$attach|$additional";
</search for>

<add after>
			$isinorder = 0;
			fopen(NPORDER, ">$vardir/nopostorder.txt",1);
			for ($i = 0; $i < @nopostorder; $i++) {
				chomp $nopostorder[$i];
				if($NoPost{$nopostorder[$i]}) {
					print NPORDER "$nopostorder[$i]\n";
					if($nopostorder[$i] == $noposts) { $isinorder = 1; }
				}
			}
			if(!$isinorder) { print NPORDER "$noposts\n"; }
			fclose(NPORDER);
</add after>


<search for>
	&MemberIndex("rebuild");
	$yySetLocation = qq~$adminurl?action=modmemgr~;
</search for>

<add before>
	fopen(NPORDER, ">$vardir/nopostorder.txt",1);
	for ($i = 0; $i < @nopostorder; $i++) {
		chomp $nopostorder[$i];
		if($NoPost{$nopostorder[$i]}) {
			print NPORDER "$nopostorder[$i]\n";
		}
	}
	fclose(NPORDER);

</add before>

<search for>
1;
</search for>

<add before>
sub reorderGroups {
$selsize = 0;
foreach (@nopostorder) {
	chomp $_;
	if($NoPost{$_}) {
		($title, undef) = split(/\|/, $NoPost{$_}, 2);
		if ($_ eq $INFO{"thegroup"}) {
			$orderopt .= qq~<option value="$_" selected="selected">$title</option>~;
		}
		else {
			$orderopt .= qq~<option value="$_">$title</option>~;
		}
		$selsize++;
	}
}

$rowspan = $#nopostorder + 2;
$yymain .= qq~
	<div class="bordercolor" style="padding: 0px; width: 75%; margin-left: auto; margin-right: auto;">
		<table width="100%" cellspacing="1" cellpadding="4">
			<tr valign="middle">
				<td align="left" class="titlebg" colspan="3">
					<img src="$imagesdir/guest.gif" alt="" border="0" />&nbsp;<b>$admintxt{'reordergroups2'}</b>
				</td>
			</tr>
			<tr valign="middle">
				<td align="center" class="catbg" width="33%"><b>$amgtxt{'03'}</b></td>
				<td align="center" class="catbg" width="33%"><b>$amgtxt{'19'}</b></td>
				<td align="center" class="windowbg" width="34%" rowspan="$rowspan">
					<form action="$adminurl?action=reordergroup2" method="post" name="groupsorder" style="display: inline; white-space: nowrap;">
					<select name="ordergroups" class="small" size="$selsize" style="width: 130px;">
						$orderopt
					</select><br />
					<input type="submit" value="$admin_txt{'739a'}" name="moveup" style="font-size: 11px; width: 65px;" class="button" /><input type="submit" value="$admin_txt{'739b'}" name="movedown" style="font-size: 11px; width: 65px;" class="button" />
					</form>
				</td>
			</tr>
~;
	foreach (@nopostorder) {
		chomp $_;
		($title, $stars, $starpic, $color, undef) = split(/\|/, $NoPost{$_}, 5);
		if (!$stars) { $stars = "0"; }
$yymain .= qq~
			<tr>
				<td align="left" class="windowbg2">
~;

					if ($color) { $yymain .= qq~<span style="color:$color"><b>$title</b></span>~; }
					else { $yymain .= qq~<b>$title</b>~; }
$yymain .= qq~

				</td>
				<td align="center" class="windowbg2">
~;
					for(1..$stars) { $yymain .= qq~<img src="$imagesdir/$starpic" />~; }
$yymain .= qq~
				</td>
			</tr>
~;
	}

$yymain .= qq~

		</table>
	</div>
~;
$yytitle = $admintxt{'reordergroups'};
$action_area = 'modmemgr';
&AdminTemplate;
exit;
}

sub reorderGroups2 {
$moveitem = $FORM{'ordergroups'};

if($moveitem) {
	if ($FORM{'moveup'}) {
		for ($i = 0; $i < @nopostorder; $i++) {
			chomp $nopostorder[$i];
			if ($nopostorder[$i] eq $moveitem && $i > 0) {
				$j = $i - 1;
				$nopostorder[$i] = $nopostorder[$j];
				$nopostorder[$j] = $moveitem;
				last;
			}
		}
	}
	elsif ($FORM{'movedown'}) {
		for ($i = 0; $i < @nopostorder; $i++) {
			chomp $nopostorder[$i];
			if ($nopostorder[$i] eq $moveitem && $i < $#nopostorder) {
				$j = $i + 1;
				$nopostorder[$i] = $nopostorder[$j];
				$nopostorder[$j] = $moveitem;
				last;
			}
		}
	}
}

fopen(NPORDER, ">$vardir/nopostorder.txt",1);
for ($i = 0; $i < @nopostorder; $i++) {
	chomp $nopostorder[$i];
	print NPORDER "$nopostorder[$i]\n";
}
fclose(NPORDER);

$yySetLocation = qq~$adminurl?action=reordergroup;thegroup=$moveitem~;
&redirectexit;
}

</add before>


<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$reordernopostgrp_mod = qq~Reorder Post independent Member Groups for YaBB 2.2|Carsten|This mod will allow admin to reorder post independent member groups.|1.0|01/14/08~;
	push (@installed_mods, "$reordernopostgrp_mod");

</add before>


<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
'45' => 'Add',
</search for>

<add after>
'reordergroups' => 'Reorder',
'reordergroups2' => 'Reorder Post independent Member Groups',
</add after>


<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
	$grpcolors = '';
	($title, undef, undef, $color, $noshow) = split(/\|/, $Group{'Administrator'}, 5);
	if ($color && $noshow != 1) { $grpcolors .= qq~<div class="small" style="float: left; width: 49%;"><span style="color: $color;"><b>lllll</b></span> $title</div>~; }
	($title, undef, undef, $color, $noshow) = split(/\|/, $Group{'Global Moderator'}, 5);
	if ($color && $noshow != 1) { $grpcolors .= qq~<div class="small" style="float: left; width: 49%;"><span style="color: $color;"><b>lllll</b></span> $title</div>~; }
	foreach $nopostamount (sort { $a <=> $b } keys %NoPost) {
		($title, undef, undef, $color, $noshow) = split(/\|/, $NoPost{$nopostamount}, 5);
		if ($color && $noshow != 1) { $grpcolors .= qq~<div class="small" style="float: left; width: 49%;"><span style="color: $color;"><b>lllll</b></span> $title</div>~; }
	}
	foreach $postamount (sort { $b <=> $a } keys %Post) {
		($title, undef, undef, $color, $noshow) = split(/\|/, $Post{$postamount}, 5);
		if ($color && $noshow != 1) { $grpcolors .= qq~<div class="small" style="float: left; width: 49%;"><span style="color: $color;"><b>lllll</b></span> $title</div>~; }
	}
</search for>

<replace>
	my %tmpcolors;
	$tmpcnt = 0;
	$grpcolors = '';
	($title, undef, undef, $color, $noshow) = split(/\|/, $Group{'Administrator'}, 5);
	if ($color && $noshow != 1) {
		$tmpcnt++;
		$tmpcolors{$tmpcnt} = qq~<div class="small" style="float: left; width: 49%;"><span style="color: $color;"><b>lllll</b></span> $title</div>~;
	}
	($title, undef, undef, $color, $noshow) = split(/\|/, $Group{'Global Moderator'}, 5);
	if ($color && $noshow != 1) {
		$tmpcnt++;
		$tmpcolors{$tmpcnt} = qq~<div class="small" style="float: left; width: 49%;"><span style="color: $color;"><b>lllll</b></span> $title</div>~;
	}
	foreach $nopostamount (@nopostorder) {
		chomp $nopostamount;
		($title, undef, undef, $color, $noshow) = split(/\|/, $NoPost{$nopostamount}, 5);
		if ($color && $noshow != 1) {
			$tmpcnt++;
			$tmpcolors{$tmpcnt} = qq~<div class="small" style="float: left; width: 49%;"><span style="color: $color;"><b>lllll</b></span> $title</div>~;
		}
	}
	foreach $postamount (sort { $b <=> $a } keys %Post) {
		($title, undef, undef, $color, $noshow) = split(/\|/, $Post{$postamount}, 5);
		if ($color && $noshow != 1) {
			$tmpcnt++;
			$tmpcolors{$tmpcnt} = qq~<div class="small" style="float: left; width: 49%;"><span style="color: $color;"><b>lllll</b></span> $title</div>~;
		}
	}
	$rows = int(($tmpcnt / 2) + 0.5);
	$col1 = 1;
	for(1..$rows) {
		$col2 = $rows + $col1;
		if($tmpcolors{$col1}) { $grpcolors .= qq~$tmpcolors{$col1}~; }
		if($tmpcolors{$col2}) { $grpcolors .= qq~$tmpcolors{$col2}~; }
		$col1++;
	}
	undef %tmpcolors;
</replace>


<edit file>
Sources/Profile.pl
</edit file>

<search for>
	if ($addmemgroup_enabled == 2 || $addmemgroup_enabled == 3) {
		foreach (sort { $a <=> $b } keys %NoPost) {
</search for>

<replace>
	if ($addmemgroup_enabled == 2 || $addmemgroup_enabled == 3) {
		foreach (@nopostorder) {
			chomp $_;
</replace>

<search for>
	foreach (sort { $a <=> $b } keys %NoPost) {
</search for>

<replace>
	foreach (@nopostorder) {
		chomp $_;
</replace>


<search for>
			foreach my $key (sort { $a <=> $b } keys %NoPost) {
</search for>

<replace>
			foreach my $key (@nopostorder) {
				chomp $key;
</replace>

<edit file>
Sources/Register.pl
</edit file>

<search for>
		foreach (sort { $a <=> $b } keys %NoPost) {
</search for>

<replace>
		foreach (@nopostorder) {
			chomp $_;
</replace>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
sub automaintenance {
</search for>

<add before>
sub nopostorder {
	if (!-e "$vardir/nopostorder.txt") {
		fopen(NPORDER, ">$vardir/nopostorder.txt",1);
		while (($nopostkey, $nopostvalue) = each(%NoPost)) {
			print NPORDER "$nopostkey\n";
		}
		fclose(NPORDER);
	}
	fopen(NPORDER, "$vardir/nopostorder.txt");
	@nopostorder = <NPORDER>;
	fclose(NPORDER);
}

</add before>

<edit file>
Sources/UserSelect.pl
</edit file>

<search for>
		foreach (sort { $a <=> $b } keys %NoPost) {
</search for>

<replace>
		foreach (@nopostorder) {
			chomp $_;
</replace>

